Bug 207104 - Allow lsof and fuser to access nptl threads [NEEDINFO]
Allow lsof and fuser to access nptl threads
Status: CLOSED WONTFIX
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: lsof (Show other bugs)
4.4
All Linux
high Severity medium
: ---
: ---
Assigned To: Karel Zak
Brock Organ
: FutureFeature, Triaged
Depends On: 184338
Blocks: 391511
  Show dependency treegraph
 
Reported: 2006-09-19 09:48 EDT by Kent Baxley
Modified: 2010-10-22 02:04 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-08-02 22:27:57 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
dmair: needinfo? (kbaxley)


Attachments (Terms of Use)

  None (edit)
Comment 2 RHEL Product and Program Management 2008-02-01 14:12:12 EST
This request was evaluated by Red Hat Product Management for
inclusion, but this component is not scheduled to be updated in
the current Red Hat Enterprise Linux release. If you would like
this request to be reviewed for the next minor release, ask your
support representative to set the next rhel-x.y flag to "?".
Comment 3 Issue Tracker 2008-03-07 12:34:28 EST
For PM:

Who is the sales sponsor? Stephen McCann

What is the Red Hat business oportunity with this customer?

Due to budgetary issues and large layoffs, the customer will not be
migrating to RHEL5 any time soon (they'll be staying on RHEL4 for years,
possibly).  The fix for this problem is in upstream, and is in RHEL5's
lsof already.  The developers have indicated that the fix appears safe,
and should port to RHEL4 without issues. The uses lsof in their debugging
work, so, having one that works, is essential to daily operations. SLAC is
a loyal RHEL customer, so, we should try to work with them on this.




This event sent from IssueTracker by kbaxley 
 issue 44127
Comment 5 Issue Tracker 2008-03-07 13:53:02 EST
Here was the original bug report:

https://bugzilla.redhat.com/show_bug.cgi?id=184338

There, the developer assigned to the case said that this could also be
considered a bug rather than a feature (comment #22), and that porting to
to RHEL4 wouldn't be entirely impossible. Can't we do something based on
that?


This event sent from IssueTracker by kbaxley 
 issue 44127
Comment 10 Issue Tracker 2008-03-27 21:38:14 EDT
No Problem.  Here's a comparison of what I'm seeing on RHEL5 vs RHEl4. 
If you've got any other questions, let me know.

RHEL5:

1) I kicked off the test program (./test1)

2) run ps am to find the process id of the test, which in this case is
13270:

[root@tuxracer ~]# ps am
  PID TTY      STAT   TIME COMMAND
 5309 tty1     -      0:00 /sbin/mingetty tty1
    - -        Ss+    0:00 -
 5310 tty2     -      0:00 /sbin/mingetty tty2
    - -        Ss+    0:00 -
 5311 tty3     -      0:00 /sbin/mingetty tty3
    - -        Ss+    0:00 -
 5312 tty4     -      0:00 /sbin/mingetty tty4
    - -        Ss+    0:00 -
 5317 tty5     -      0:00 /sbin/mingetty tty5
    - -        Ss+    0:00 -
 5319 tty6     -      0:00 /sbin/mingetty tty6
    - -        Ss+    0:00 -
 5418 tty7     -      0:00 /usr/bin/Xorg :0 -br -audit 0 -auth
/var/gdm/:0.Xauth -nolisten tcp vt7
    - -        Ss+    0:00 -
 9855 pts/1    -      0:00 -bash
    - -        Ss     0:00 -
10004 pts/2    -      0:00 -bash
    - -        Ss     0:00 -
13270 pts/1    -      0:00 [test1] <defunct>
    - -        Zl+    0:00 -
    - -        Sl+    0:00 -
13273 pts/2    -      0:00 ps am
    - -        R+     0:00 -

Next run an ls -al on /proc/13270/fd:


[root@tuxracer ~]# ls -al /proc/13270/fd
total 0
dr-x------ 2 root root 0 Mar 27 09:47 .
dr-xr-xr-x 5 root root 0 Mar 27 09:47 ..

On RHEL4, with the RHEL5 version of lsof, run the same test program:

1) Next run ps am 

[root@dhcp243-50 ~]# ps am
  PID TTY      STAT   TIME COMMAND
 2946 tty2     -      0:00 /sbin/mingetty tty2
    - -        Ss+    0:00 -
 2947 tty3     -      0:00 /sbin/mingetty tty3
    - -        Ss+    0:00 -
 2948 tty4     -      0:00 /sbin/mingetty tty4
    - -        Ss+    0:00 -
 2949 tty5     -      0:00 /sbin/mingetty tty5
    - -        Ss+    0:00 -
 2950 tty6     -      0:00 /sbin/mingetty tty6
    - -        Ss+    0:00 -
 3552 tty1     -      0:00 -bash
    - -        Ss     0:00 -
 3596 pts/0    -      0:00 -bash
    - -        Ss     0:00 -
 3902 tty1     -      0:00 [test] <defunct>
 4199 pts/0    -      0:00 ps am
    - -        R+     0:00 -
2) run ls -al against /proc/3902:

[root@dhcp243-50 ~]# ls -al /proc/3902/fd
ls: /proc/3902/fd: No such file or directory

According to the developer, lsof in RHEL4 does not check
/proc/<PID>/task/<TID>/fd directories. So, it means files from
/proc/<PID>/task/<TID>/fd are invisible for lsof.

The other problem on RHEL4 appears to be that there is no /proc/task/
directory structure...that I can see, anyway.

My guess here is that some additional tweaks might need to be made to make
this work on RHEL4.

Internal Status set to 'Waiting on SEG'

This event sent from IssueTracker by dmair 
 issue 44127
Comment 12 Issue Tracker 2008-04-30 11:05:12 EDT
Ok.  I got an email from the customer this morning.  Apparently SLAC is
fine with dropping this.  From my onsite visit last week, it appears that
they're going to start pushing the right buttons resource-wise to start
migrating to RHEL5.  

From: Karl Amrhein <ksa@slac.stanford.edu>
To: Kent Baxley <kbaxley@redhat.com>
Subject: Re: Ticket number44127 Allow lsof and fuser to access nptl
threads
Date: Tue, 29 Apr 2008 15:51:31 -0700
User-Agent: Mutt/1.5.16 (2007-06-09)

Our developer finally responded to me today.  
He is fine with just closing the ticket.

Karl



This event sent from IssueTracker by kbaxley 
 issue 44127
Comment 15 RHEL Product and Program Management 2008-08-02 22:27:57 EDT
Product Management has reviewed and declined this request.  You may appeal this
decision by reopening this request.

Note You need to log in before you can comment on or make changes to this bug.